Index: trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp
===================================================================
--- trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 405)
+++ trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 434)
@@ -2285,619 +1428,432 @@
     } // end switch CONFIG_RSP FSM
 
-
-    ////////////////////////////////////////////////////////////////////////////
-    // The ALLOC_TRT_CONFIG fsm allocates the access to the Transaction Table (m_transaction_tab_config)
-    // with a round robin priority between 2 user FSMs :
-    // - CONFIG_CMD : to set a new entry
-    // - CONFIG_RSP : to read and erase an entry
-    // The ressource is always allocated.
+    /////////////////////////////////////////////////////////////////////////////////
+    // If the IOB component has IRQ ports, the IRQ FSM detects all changes 
+    // on the 32 p_irq[i] ports and request a VCI write transaction to the 
+    // MISS_INIT FSM, using the 64 r_irq_request[i] and r_irq_pending[i] flip-flops.
+    /////////////////////////////////////////////////////////////////////////////////
+
+    if ( m_has_irqs )
+    {
+        for ( size_t i = 0; i<32; ++i )
+        {
+            r_irq_request[i] = ( p_irq[i]->read() == not r_irq_pending[i].read() );
+            r_irq_pending[i] = p_irq[i]->read();
+        }
+    }
+        
+    ///////////////////////////////////////////////////////////////////////////////////
+    // The MISS_WTI_CMD FSM send VCI commands on the Internal Network.
+    // It handles PTE MISS requests from TLB_MISS FSM and software IRQs.
+    // It supports several simultaneous VCI transactions.
     ////////////////////////////////////////////////////////////////////////////////////
-    
-    switch ( r_alloc_trt_config_fsm.read() ) 
-    {
-    ///////////////////
-    case ALLOC_TRT_CONFIG_CMD:
-    {
-        if ( r_config_cmd_fsm.read() != CONFIG_CMD_TRT_LOCK ) 
-        {
-          if (r_config_rsp_fsm.read() == CONFIG_RSP_TRT_LOCK) r_alloc_trt_config_fsm = ALLOC_TRT_CONFIG_RSP;
-        }
-    }
-    ///////////////////
-    case ALLOC_TRT_CONFIG_RSP:
-    {
-        if (r_config_rsp_fsm.read() != CONFIG_RSP_TRT_LOCK) 
-        {
-            if (r_config_cmd_fsm.read() == CONFIG_CMD_TRT_LOCK) r_alloc_trt_config_fsm = ALLOC_TRT_CONFIG_CMD;
-        }
-    }
-    } // end switch r_alloc_trt_config_fsm
-
-    ////////////////////////////////////////////////////////////////////////////
-    // The MISS_INIT FSM sends a page table entry miss request into Direct Noc
-    // It controls the following ressources:
-    // - r_miss_init_fsm
-    // - r_tlb_miss_init_req (reset)
-    // - r_miss_buf_data
-    // - r_miss_buf_valid
-    // - r_miss_buf_tag
-    ////////////////////////////////////////////////////////////////////////////////////
-
-    // Building the interruption vector (systematically)
-    uint32_t irq_demands = 0;
-    for ( size_t i = 0; i<m_nb_periph; ++i )
-        irq_demands |= (p_irq_in[i].read() ? 1 : 0) << i;
-    
-    // For next cycle:
-        // Afectation of the new pending vector. 
-        // Not useful, unless Irq choice is postponed to next cycle
-    r_irq_pending = irq_demands & r_irq_mask.read();
-        // Updating Mask
-    r_irq_mask = r_irq_mask.read()| ~irq_demands;  
-    
  
-    switch ( r_miss_init_fsm.read() ) 
-    {
-        //////////////
-        case MISS_INIT_IDLE_MISS:
-        {
-            if(r_tlb_miss_init_req.read())
+    switch ( r_miss_wti_cmd_fsm.read() ) 
+    {
+        ///////////////////////
+        case MISS_WTI_CMD_IDLE:   // TLB MISS have highest priority
+        {
+            if ( r_tlb_miss_req.read() )
             {
-                r_miss_init_fsm = MISS_INIT_TLB_MISS_CMD;
+                r_miss_wti_cmd_fsm = MISS_WTI_CMD_MISS;
             }
-            else if (irq_demands & r_irq_mask.read()){
-                // Choosing one interruption to send            
-                // Find the first bit 1 
-                // starting by the bit just after the last chosen
-                size_t i = (r_irq_chosen.read() + 1)% m_nb_periph;
+            else if ( r_iommu_wti_enable.read() )
+            {
+                // checking if there is a new pending interrupt
                 bool found = false;
-                do
-                {
-                    if(irq_demands & r_irq_mask.read() & (1<<i)) 
-                    {
-                        r_irq_chosen = i;
-                        found = true;
-                    }
-                    i = (i+1) % m_nb_periph;
-                }
-                while(i != r_irq_chosen.read()+1 && !found); 
-
-                r_miss_init_fsm = MISS_INIT_IRQ_CMD;
+                size_t n;
+                for ( n = 0 ; (n < 32) and not found ; n++ )
+                {
+                    if ( r_irq_request[n] ) found = true;
+                }
+                if ( found )
+                {
+                    r_miss_wti_cmd_index = n;
+                    r_miss_wti_cmd_fsm   = MISS_WTI_CMD_WTI;
+                }
             }
 			break;
         }
-        //////////////
-        case MISS_INIT_IDLE_IRQ:
-        {
-            if (irq_demands & r_irq_mask.read()){
-                // Choosing one interruption to send            
-                // Find the first bit 1 
-                // starting by the bit just after the last chosen
-                size_t i = (r_irq_chosen.read() + 1)% m_nb_periph;
-                bool found = false;
-                do
-                {
-                    if(irq_demands & r_irq_mask.read() & (1<<i)) 
-                    {
-                        r_irq_chosen = i;
-                        found = true;
-                    }
-                    i = (i+1) % m_nb_periph;
-                }
-                while(i != r_irq_chosen.read()+1 && !found); 
-
-                r_miss_init_fsm = MISS_INIT_IRQ_CMD;
-            }
-            else if(r_tlb_miss_init_req.read())
+        //////////////////////     
+        case MISS_WTI_CMD_WTI:   // send a single flit IRQ WRITE on INT Network
+                                 // address is defined by IRQ_VECTOR[r_miss_wti_index]
+                                 // data is defined by r_irq_pending[r_miss_wti_index]
+        {
+            if ( p_vci_ini_int.cmdack ) 
             {
-                r_miss_init_fsm = MISS_INIT_TLB_MISS_CMD;
-            }
-			break;
-        }
-        /////////////////////////       // send a read request to Direct Network
-        case MISS_INIT_IRQ_CMD: 
-        {
-        if ( p_vci_ini_miss.cmdack ) 
-        {
-            // Masking chosen interruption, until it is resolved 
-            r_irq_mask = r_irq_mask.read() & ~(1<<r_irq_chosen.read());
-            r_miss_init_fsm = MISS_INIT_IRQ_RSP;		
-
-#if DEBUG_MISS_INIT
-if( m_debug_miss_init_fsm )
-{
-    std::cout << "  <IOB.MISS_INIT_IRQ_CMD> Send write (irq) command to XICU"
-              << " irq ID = " << std::dec << r_irq_chosen.read()
-              << " new mask = " << std::hex << (r_irq_mask.read() & ~(1<<r_irq_chosen.read()))
-     << std::endl;
-}
-#endif
-        }
-            break;
-        }
-        //////////////////
-        case MISS_INIT_IRQ_RSP:	
-        {
-            if ( p_vci_ini_miss.rspval.read() ) 
-            {
-                // It is a WRITE command, response in one single flit long
-                assert( p_vci_ini_miss.reop.read() and "Write answer should have one single flit" ); 
-                bool error;
-                
-                if ( (p_vci_ini_miss.rerror.read()&0x1) != 0 )  // error reported
-                {
-                    // TODO traiter error
-                    error = true;
-                }
-                r_miss_init_fsm = MISS_INIT_IDLE_MISS;
+                // reset the request
+                r_irq_request[r_miss_wti_cmd_index.read()] = false;
+                r_miss_wti_cmd_fsm = MISS_WTI_RSP_WTI;		
+
+#if DEBUG_MISS_WTI
+if( m_debug_activated )
+std::cout << "  <IOB MISS_WTI_CMD_WTI> Send WTI write command on Internal Network"
+          << " / IRQID = " << std::dec << r_miss_wti_cmd_index.read() << std::endl;
+#endif
             }
             break;
         }
-        /////////////////////////       // send a read request to Direct Network
-        case MISS_INIT_TLB_MISS_CMD: 
-        {
-        if ( p_vci_ini_miss.cmdack ) 
-        {
-            r_miss_rsp_cpt  = 0;    //counter for the response flits
-            r_miss_buf_tag  = ( (r_iotlb_paddr.read()) & CACHE_LINE_MASK ); 
-            r_miss_buf_valid = true;
+        ///////////////////////
+        case MISS_WTI_CMD_MISS:   // send a TLB MISS request on INT Network
+        {
+            if ( p_vci_ini_int.cmdack ) 
+            {
+                r_tlb_buf_tag     = ( (r_tlb_paddr.read()) & CACHE_LINE_MASK ); 
+                r_tlb_buf_valid   = true;
             
-            if(r_tlb_miss_type.read()== PTE1_MISS)
-                r_miss_buf_vaddr_begin =(r_iotlb_vaddr.read() & ~M_PAGE_OFFSET_MASK & ~PTE1_LINE_OFFSET);
-            else
-                r_miss_buf_vaddr_begin =(r_iotlb_vaddr.read() & ~K_PAGE_OFFSET_MASK & ~PTE2_LINE_OFFSET);
+                if( r_tlb_miss_type.read() == PTE1_MISS )
+                    r_tlb_buf_vaddr = (r_dma_cmd_vaddr.read() & 
+                                        ~M_PAGE_OFFSET_MASK & ~PTE1_LINE_OFFSET);
+                else
+                    r_tlb_buf_vaddr = (r_dma_cmd_vaddr.read() & 
+                                        ~K_PAGE_OFFSET_MASK & ~PTE2_LINE_OFFSET);
                 
-            r_miss_init_fsm = MISS_INIT_TLB_MISS_RSP;		
-
-#if DEBUG_MISS_INIT
-if( m_debug_miss_init_fsm )
-{
-    std::cout << "  <IOB.MISS_INIT_TLB_MISS_CMD> Send read (tlb entry) request to MEM CACHE: "
-    << " | address :  "<< std::hex <<(paddr_t)((r_iotlb_paddr.read())& CACHE_LINE_MASK)
-    << std::endl;
-}
-#endif
-        }
+                r_miss_wti_cmd_fsm = MISS_WTI_RSP_MISS;		
+
+#if DEBUG_MISS_WTI
+if( m_debug_activated )
+std::cout << "  <IOB MISS_WTI_CMD_MISS> Send TLB MISS command on Internal Network" << std::hex
+          << " / address = " <<(vci_addr_t)((r_tlb_paddr.read())& CACHE_LINE_MASK) << std::endl;
+#endif
+            }
             break;
         }
-        //////////////////
-        case MISS_INIT_TLB_MISS_RSP:	
-        {
-            if ( p_vci_ini_miss.rspval.read() ) 
+    } // end switch r_miss_wti_cmd_fsm
+
+    ///////////////////////////////////////////////////////////////////////////////////
+    // The MISS_WTI_RSP FSM handles VCI responses on the Internal Network.
+    // it can be response to TLB MISS (read transaction) or WTI (write transaction).
+    // It supports several simultaneous VCI transactions.
+    ////////////////////////////////////////////////////////////////////////////////////
+ 
+    switch ( r_miss_wti_rsp_fsm.read() ) 
+    {
+        case MISS_WTI_RSP_IDLE:   // waiting a VCI response
+        {
+            if ( p_vci_ini_int.rspval.read() ) 
             {
-                if ( (p_vci_ini_miss.rerror.read()&0x1) != 0 )  // error reported
-                {
-                    r_miss_init_error = true;
-                    if ( p_vci_ini_miss.reop.read() ) 
+                if ( p_vci_ini_int.rpktid.read() == PKTID_READ )  // it's a TLB MISS response
+                {
+                    r_miss_wti_rsp_fsm   = MISS_WTI_RSP_MISS;
+                    r_miss_wti_rsp_count = 0;
+                }
+                else                                       // it's a WTI WRITE response
+                {
+                    r_miss_wti_rsp_fsm   = MISS_WTI_RSP_WTI;
+
+                }
+            }
+            break;
+        }
+        //////////////////////
+        case MISS_WTI_RSP_WTI:   // Handling response to a WTI transaction
+        {
+            assert( p_vci_ini_int.reop.read() and 
+            "VCI_IO_BRIDGE ERROR: IRQ Write response should have one single flit" ); 
+
+            assert( ( (p_vci_ini_int.rerror.read()&0x1) == 0 ) and 
+            "VCI_IO_BRIDGE ERROR: IRQ Write response error !!!" ); 
+             // TODO traiter error using the IOMMU IRQ
+
+#if DEBUG_MISS_WTI
+if( m_debug_activated )
+std::cout << "  <IOB MISS_WTI_RSP_WTI> Response to WTI write" << std::endl;
+#endif
+            r_miss_wti_rsp_fsm = MISS_WTI_RSP_IDLE;
+            break;
+        }
+        ///////////////////////
+        case MISS_WTI_RSP_MISS:   // Handling response to a TLB MISS transaction
+        {
+            if ( p_vci_ini_int.rspval.read() ) 
+            {
+                if ( (p_vci_ini_int.rerror.read()&0x1) != 0 )  // error reported
+                {
+                    r_miss_wti_rsp_error = true;
+                    if ( p_vci_ini_int.reop.read() ) 
                     {    
-                        r_miss_init_fsm = MISS_INIT_IDLE_IRQ;
-                        r_tlb_miss_init_req = false; 
+                        r_miss_wti_cmd_fsm = MISS_WTI_RSP_IDLE;
+                        r_tlb_miss_req = false; 
                     }
-#if DEBUG_MISS_INIT
-if( m_debug_miss_init_fsm ) 
-{
-    std::cout << " <IOB.MISS_INIT_TLB_MISS_RSP> ERROR " << std::endl; 
-}
-#endif
-                }
-                else
+#if DEBUG_MISS_WTI
+if( m_debug_activated ) 
+std::cout << " <IOB MISS_WTI_RSP_MISS> ERROR " << std::endl; 
+#endif
+                }
+                else                                           // no error
                 { 
-                    bool   eop  	= p_vci_ini_miss.reop.read();
-
-
-#if DEBUG_MISS_INIT
-if( m_debug_miss_init_fsm ) 
-{
-    std::cout << "  <IOB.MISS_INIT_TLB_MISS_RSP> Response from Mem Cache to a read (tlb entry) transaction. Count = " << r_miss_rsp_cpt.read()
-    <<" | Data = " << std::hex << p_vci_ini_miss.rdata.read() << std::endl; 
-}
-#endif
-
-                    assert(((eop == (r_miss_rsp_cpt.read() == (m_words-1))) ) 
-                        and "Error : invalid length for a response from MEM CACHE");
-                    r_miss_buf_data[r_miss_rsp_cpt] =  (uint32_t)p_vci_ini_miss.rdata.read();
-                    
-                    r_miss_rsp_cpt = r_miss_rsp_cpt.read() + 1;
+                    bool   eop  	= p_vci_ini_int.reop.read();
+
+#if DEBUG_MISS_WTI 
+if( m_debug_activated ) 
+std::cout << "  <IOB MISS_WTI_RSP_MISS> Response to a tlb miss transaction"
+          << " / Count = " << r_miss_wti_rsp_count.read()
+          << " / Data = " << std::hex << p_vci_ini_int.rdata.read() << std::endl; 
+#endif
+                    assert(((eop == (r_miss_wti_rsp_count.read() == (m_words-1)))) and 
+                    "VCI_IO_BRIDGE ERROR: invalid length for a TLB MISS response");
+
+                    r_tlb_buf_data[r_miss_wti_rsp_count.read()] = p_vci_ini_int.rdata.read();
+                    r_miss_wti_rsp_count = r_miss_wti_rsp_count.read() + 1;
                     
                     if ( eop ) 
                     {
-                        r_tlb_miss_init_req = false;     //reset the request flip-flop
-                        r_miss_init_fsm = MISS_INIT_IDLE_IRQ;		
+                        r_tlb_miss_req = false;     //reset the request flip-flop
+                        r_miss_wti_cmd_fsm = MISS_WTI_RSP_IDLE;		
                     }
-
                 }
             }
             break;
         }
-
-    } // end  switch r_miss_init_fsm
+    } // end  switch r_miss_wti_rsp_fsm
+
+    /////////////////////////////////////////////////////////////////////////
+    // This flip-flop allocates the access to the CONFIG_RSP fifo
+    // with a round robin priority between 2 clients FSMs :
+    // - CONFIG_CMD : to put a response to a local config command.
+    // - CONFIG_RSP : to put a response to a peripheral config command.
+    // The ressource is always allocated.
+    // A new allocation occurs when the owner FSM is not using it,
+    // and the other FSM is requiring it.
+    /////////////////////////////////////////////////////////////////////////
     
-    //////////////////////////////////
-    // Fifo consumption arbitration //
-    //////////////////////////////////
+    if ( r_alloc_fifo_config_rsp_local.read() )
+    {
+        if ( (r_config_rsp_fsm.read() == CONFIG_RSP_FIFO_PUT) and
+             (r_config_cmd_fsm.read() != CONFIG_CMD_FIFO_PUT_RSP) )
+        r_alloc_fifo_config_rsp_local = false;
+    }
+    else 
+    {
+        if ( (r_config_cmd_fsm.read() == CONFIG_CMD_FIFO_PUT_RSP) and
+             (r_config_rsp_fsm.read() != CONFIG_RSP_FIFO_PUT) )
+        r_alloc_fifo_config_rsp_local = true;
+    }
+
+    /////////////////////////////////////////////////////////////////////////
+    // This flip-flop allocates the access to the DMA_RSP fifo
+    // with a round robin priority between 2 clients FSMs :
+    // - DMA_CMD : to put a error response in case of bad address translation
+    // - DMA_RSP : to put a normal response to a DMA transaction.
+    // The ressource is always allocated.
+    // A new allocation occurs when the owner FSM is not using it,
+    // and the other FSM is requiring it.
+    /////////////////////////////////////////////////////////////////////////
     
-    // Round Robin priority for CONFIG_RSP FIFO consumption
-    r_config_rsp_fifo_local_priority = ! r_config_rsp_fifo_local_priority.read(); 
-    
-    //DMA CMD
-    dma_cmd_fifo_get = (p_vci_ini_dma.cmdack.read() && m_dma_cmd_addr_fifo.rok());
-    // DMA RSP
-    dma_rsp_fifo_get = (p_vci_tgt_dma.rspack.read() && m_dma_rsp_data_fifo.rok());
-    // CONFIG CMD
-    config_cmd_fifo_get = (p_vci_ini_config.cmdack.read() && m_config_cmd_addr_fifo.rok() );
-    // CONFIG RSP, detemines wich fifo to consume 
-    if(r_config_rsp_fifo_local_priority)
-    {
-        if(m_config_local_data_fifo.rok()) config_local_fifo_get = p_vci_tgt_config.rspack.read();
-        else if (m_config_rsp_data_fifo.rok()) config_rsp_fifo_get = p_vci_tgt_config.rspack.read();
-            
-    }
-    else
-    {
-        if (m_config_rsp_data_fifo.rok()) config_rsp_fifo_get = p_vci_tgt_config.rspack.read();
-        else if(m_config_local_data_fifo.rok()) config_local_fifo_get = p_vci_tgt_config.rspack.read();
-    }
-    ///////////////
-    //DMA_CMD Fifo
-    ///////////////
-    if(r_miss_interrupt)
-    {
-        m_dma_cmd_addr_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    r_miss_paddr.read() );
-        m_dma_cmd_cmd_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    r_miss_cmd.read() );
-        m_dma_cmd_contig_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    r_miss_contig.read() );
-        m_dma_cmd_cons_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    r_miss_cons.read() );
-        m_dma_cmd_plen_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    r_miss_plen.read() );
-        m_dma_cmd_wrap_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    r_miss_wrap.read() );
-        m_dma_cmd_cfixed_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    r_miss_cfixed.read() );
-        m_dma_cmd_clen_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    r_miss_clen.read() );
-        m_dma_cmd_srcid_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    m_srcid_dma ); //r_miss_srcid.read()
-        m_dma_cmd_trdid_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    r_miss_trdid.read() );
-        m_dma_cmd_pktid_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    r_miss_pktid.read() );
-        m_dma_cmd_data_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    r_miss_data[r_dma_cmd_count.read()-1] );
-        m_dma_cmd_be_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    r_miss_be[r_dma_cmd_count.read()-1] );
-        m_dma_cmd_eop_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    (r_dma_cmd_count.read() == 1) );
+    if ( r_alloc_fifo_dma_rsp_local.read() )
+    {
+        if ( (r_dma_rsp_fsm.read() == DMA_RSP_FIFO_PUT) and
+             (r_dma_cmd_fsm.read() != DMA_CMD_FIFO_PUT_RSP) )
+        r_alloc_fifo_dma_rsp_local = false;
     }
     else 
     {
-        m_dma_cmd_addr_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    r_dma_paddr.read() ); 
-        m_dma_cmd_cmd_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    p_vci_tgt_dma.cmd.read() );
-        m_dma_cmd_contig_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    p_vci_tgt_dma.contig.read() );
-        m_dma_cmd_cons_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    p_vci_tgt_dma.cons.read() );
-        m_dma_cmd_plen_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    p_vci_tgt_dma.plen.read() );
-        m_dma_cmd_wrap_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    p_vci_tgt_dma.wrap.read() );
-        m_dma_cmd_cfixed_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    p_vci_tgt_dma.cfixed.read() );
-        m_dma_cmd_clen_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    p_vci_tgt_dma.clen.read() );
-        m_dma_cmd_srcid_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    m_srcid_dma );
-        m_dma_cmd_trdid_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    r_dma_cmd_trt_index.read() );
-        m_dma_cmd_pktid_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    p_vci_tgt_dma.pktid.read() );
-        m_dma_cmd_data_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    p_vci_tgt_dma.wdata.read() ); // TODO change
-                                                            // For 64bits XRAM
-        m_dma_cmd_be_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                    p_vci_tgt_dma.be.read() ); 
-        m_dma_cmd_eop_fifo.update( dma_cmd_fifo_get,
-                                    dma_cmd_fifo_put,
-                                     p_vci_tgt_dma.eop.read() );
-    }
-
-    ///////////////
-    //DMA_RSP Fifo
-    ///////////////
-    if(r_dma_rsp_fsm.read() == DMA_RSP_FIFO_ERROR_PUT)
-    {
-        m_dma_rsp_data_fifo.update( dma_rsp_fifo_get,
-                                    dma_rsp_fifo_put,
-                                    0 );
+        if ( (r_dma_cmd_fsm.read() == DMA_CMD_FIFO_PUT_RSP) and
+             (r_dma_rsp_fsm.read() != DMA_RSP_FIFO_PUT) )
+        r_alloc_fifo_dma_rsp_local = true;
+    }
+
+    // Define GET signals for all output FIFOs
+    dma_cmd_fifo_get    = p_vci_ini_ram.cmdack.read();
+    dma_rsp_fifo_get    = p_vci_tgt_iox.rspack.read();
+    config_cmd_fifo_get = p_vci_ini_iox.cmdack.read();
+    config_rsp_fifo_get = p_vci_tgt_int.rspack.read();
+
+    ///////////////////////////////////////////////////////////
+    // DMA_CMD fifo update
+    // One writer : DMA_CMD FSM
+    ///////////////////////////////////////////////////////////
+
+    m_dma_cmd_addr_fifo.update(   dma_cmd_fifo_get,
+                                  dma_cmd_fifo_put,
+                                  r_dma_cmd_paddr.read() );   // address translation
+    m_dma_cmd_cmd_fifo.update(    dma_cmd_fifo_get,
+                                  dma_cmd_fifo_put,
+                                  p_vci_tgt_iox.cmd.read() );
+    m_dma_cmd_contig_fifo.update( dma_cmd_fifo_get,
+                                  dma_cmd_fifo_put,
+                                  p_vci_tgt_iox.contig.read() );
+    m_dma_cmd_cons_fifo.update(   dma_cmd_fifo_get,
+                                  dma_cmd_fifo_put,
+                                  p_vci_tgt_iox.cons.read() );
+    m_dma_cmd_plen_fifo.update(   dma_cmd_fifo_get,
+                                  dma_cmd_fifo_put,
+                                  p_vci_tgt_iox.plen.read() );
+    m_dma_cmd_wrap_fifo.update(   dma_cmd_fifo_get,
+                                  dma_cmd_fifo_put,
+                                  p_vci_tgt_iox.wrap.read() );
+    m_dma_cmd_cfixed_fifo.update( dma_cmd_fifo_get,
+                                  dma_cmd_fifo_put,
+                                  p_vci_tgt_iox.cfixed.read() );
+    m_dma_cmd_clen_fifo.update(   dma_cmd_fifo_get,
+                                  dma_cmd_fifo_put,
+                                  p_vci_tgt_iox.clen.read() );
+    m_dma_cmd_srcid_fifo.update(  dma_cmd_fifo_get,
+                                  dma_cmd_fifo_put,
+                                  p_vci_tgt_iox.srcid.read() );
+    m_dma_cmd_trdid_fifo.update(  dma_cmd_fifo_get,
+                                  dma_cmd_fifo_put,
+                                  p_vci_tgt_iox.trdid.read() );
+    m_dma_cmd_pktid_fifo.update(  dma_cmd_fifo_get,
+                                  dma_cmd_fifo_put,
+                                  p_vci_tgt_iox.pktid.read() );
+    m_dma_cmd_data_fifo.update(   dma_cmd_fifo_get,
+                                  dma_cmd_fifo_put,
+                                  p_vci_tgt_iox.wdata.read() ); 
+    m_dma_cmd_be_fifo.update(     dma_cmd_fifo_get,
+                                  dma_cmd_fifo_put,
+                                  p_vci_tgt_iox.be.read() ); 
+    m_dma_cmd_eop_fifo.update(    dma_cmd_fifo_get,
+                                  dma_cmd_fifo_put,
+                                  p_vci_tgt_iox.eop.read() );
+
+    //////////////////////////////////////////////////////////////
+    // DMA_RSP fifo update
+    // Two writers : DMA_CMD FSM & DMA_RSP FSM
+    //////////////////////////////////////////////////////////////
+
+    if (r_alloc_fifo_dma_rsp_local.read() )  // owner is DMA_CMD FSM
+                                             // local response for a translation error
+    {
+        m_dma_rsp_data_fifo.update(   dma_rsp_fifo_get,
+                                      dma_rsp_fifo_put,
+                                      0 );                      // no data if error
         m_dma_rsp_rsrcid_fifo.update( dma_rsp_fifo_get,
-                                    dma_rsp_fifo_put,
-                                    r_iommu_bad_id.read() ); 
+                                      dma_rsp_fifo_put,
+                                      p_vci_tgt_iox.rsrcid.read() ); 
         m_dma_rsp_rtrdid_fifo.update( dma_rsp_fifo_get,
-                                    dma_rsp_fifo_put,
-                                    r_dma_error_trdid.read() ); 
+                                      dma_rsp_fifo_put,
+                                      p_vci_tgt_iox.rtrdid.read() ); 
         m_dma_rsp_rpktid_fifo.update( dma_rsp_fifo_get,
-                                    dma_rsp_fifo_put,
-                                    r_dma_error_pktid.read() );
-        m_dma_rsp_reop_fifo.update( dma_rsp_fifo_get,
-                                   dma_rsp_fifo_put,
-                                   true );
+                                      dma_rsp_fifo_put,
+                                      p_vci_tgt_iox.rpktid.read() ); 
+        m_dma_rsp_reop_fifo.update(   dma_rsp_fifo_get,
+                                      dma_rsp_fifo_put,
+                                      true );                    // single flit response
         m_dma_rsp_rerror_fifo.update( dma_rsp_fifo_get,
                                       dma_rsp_fifo_put,
-                                      r_dma_error_type.read() );
-    }
-    else
-    {
-        m_dma_rsp_data_fifo.update( dma_rsp_fifo_get,
-                                    dma_rsp_fifo_put,
-                                    p_vci_ini_dma.rdata.read() );
+                                      1 );                        // error
+    }
+    else                                   // owner is DMA_RSP FSM
+                                           // normal response to a DMA transaction
+    {
+        m_dma_rsp_data_fifo.update(   dma_rsp_fifo_get,
+                                      dma_rsp_fifo_put,
+                                      p_vci_ini_ram.rdata.read() );
         m_dma_rsp_rsrcid_fifo.update( dma_rsp_fifo_get,
-                                    dma_rsp_fifo_put,
-                                    r_dma_rsrcid.read() ); 
+                                      dma_rsp_fifo_put,
+                                      p_vci_ini_ram.rsrcid.read() );
         m_dma_rsp_rtrdid_fifo.update( dma_rsp_fifo_get,
-                                    dma_rsp_fifo_put,
-                                    r_dma_rtrdid.read() ); 
+                                      dma_rsp_fifo_put,
+                                      p_vci_ini_ram.rtrdid.read() );
         m_dma_rsp_rpktid_fifo.update( dma_rsp_fifo_get,
-                                    dma_rsp_fifo_put,
-                                    p_vci_ini_dma.rpktid.read() );
-        m_dma_rsp_reop_fifo.update( dma_rsp_fifo_get,
-                                   dma_rsp_fifo_put,
-                                   p_vci_ini_dma.reop.read() );
+                                      dma_rsp_fifo_put,
+                                      p_vci_ini_ram.rpktid.read() );
+        m_dma_rsp_reop_fifo.update(   dma_rsp_fifo_get,
+                                      dma_rsp_fifo_put,
+                                      p_vci_ini_ram.reop.read() );
         m_dma_rsp_rerror_fifo.update( dma_rsp_fifo_get,
                                       dma_rsp_fifo_put,
-                                      p_vci_ini_dma.rerror.read() );
-    }
-
-    //////////////////
-    //CONFIG_CMD Fifo
-    //////////////////
-    m_config_cmd_addr_fifo.update( config_cmd_fifo_get,
-                                config_cmd_fifo_put,
-                                r_config_vaddr.read() ); 
-    m_config_cmd_cmd_fifo.update( config_cmd_fifo_get,
-                                config_cmd_fifo_put,
-                                p_vci_tgt_config.cmd.read() );
+                                      p_vci_ini_ram.rerror.read() );
+    }
+
+    ////////////////////////////////////////////////////////////////
+    // CONFIG_CMD fifo update
+    // One writer : CONFIG_CMD FSM
+    ////////////////////////////////////////////////////////////////
+
+    m_config_cmd_addr_fifo.update(   config_cmd_fifo_get,
+                                     config_cmd_fifo_put,
+                                     p_vci_tgt_int.address.read() ); 
+    m_config_cmd_cmd_fifo.update(    config_cmd_fifo_get,
+                                     config_cmd_fifo_put,
+                                     p_vci_tgt_int.cmd.read() );
     m_config_cmd_contig_fifo.update( config_cmd_fifo_get,
-                                config_cmd_fifo_put,
-                                p_vci_tgt_config.contig.read() );
-    m_config_cmd_cons_fifo.update( config_cmd_fifo_get,
-                                config_cmd_fifo_put,
-                                p_vci_tgt_config.cons.read() );
-    m_config_cmd_plen_fifo.update( config_cmd_fifo_get,
-                                config_cmd_fifo_put,
-                                p_vci_tgt_config.plen.read() );
-    m_config_cmd_wrap_fifo.update( config_cmd_fifo_get,
-                                config_cmd_fifo_put,
-                                p_vci_tgt_config.wrap.read() );
+                                     config_cmd_fifo_put,
+                                     p_vci_tgt_int.contig.read() );
+    m_config_cmd_cons_fifo.update(   config_cmd_fifo_get,
+                                     config_cmd_fifo_put,
+                                     p_vci_tgt_int.cons.read() );
+    m_config_cmd_plen_fifo.update(   config_cmd_fifo_get,
+                                     config_cmd_fifo_put,
+                                     p_vci_tgt_int.plen.read() );
+    m_config_cmd_wrap_fifo.update(   config_cmd_fifo_get,
+                                     config_cmd_fifo_put,
+                                     p_vci_tgt_int.wrap.read() );
     m_config_cmd_cfixed_fifo.update( config_cmd_fifo_get,
-                                config_cmd_fifo_put,
-                                p_vci_tgt_config.cfixed.read() );
-    m_config_cmd_clen_fifo.update( config_cmd_fifo_get,
-                                config_cmd_fifo_put,
-                                p_vci_tgt_config.clen.read() );
-    m_config_cmd_srcid_fifo.update( config_cmd_fifo_get,
-                                config_cmd_fifo_put,
-                                m_srcid_config );
-    m_config_cmd_trdid_fifo.update( config_cmd_fifo_get,
-                                config_cmd_fifo_put,
-                                r_config_cmd_trt_index.read() ); 
-    m_config_cmd_pktid_fifo.update( config_cmd_fifo_get,
-                                config_cmd_fifo_put,
-                                p_vci_tgt_config.pktid.read() );
-    m_config_cmd_data_fifo.update( config_cmd_fifo_get,
-                                config_cmd_fifo_put,
-                                p_vci_tgt_config.wdata.read() );
-    m_config_cmd_be_fifo.update( config_cmd_fifo_get,
-                                config_cmd_fifo_put,
-                                p_vci_tgt_config.be.read() );
-    m_config_cmd_eop_fifo.update( config_cmd_fifo_get,
-                                    config_cmd_fifo_put,
-                                     p_vci_tgt_config.eop.read() );
+                                     config_cmd_fifo_put,
+                                     p_vci_tgt_int.cfixed.read() );
+    m_config_cmd_clen_fifo.update(   config_cmd_fifo_get,
+                                     config_cmd_fifo_put,
+                                     p_vci_tgt_int.clen.read() );
+    m_config_cmd_srcid_fifo.update(  config_cmd_fifo_get,
+                                     config_cmd_fifo_put,
+                                     p_vci_tgt_int.srcid.read() );
+    m_config_cmd_trdid_fifo.update(  config_cmd_fifo_get,
+                                     config_cmd_fifo_put,
+                                     p_vci_tgt_int.trdid.read() ); 
+    m_config_cmd_pktid_fifo.update(  config_cmd_fifo_get,
+                                     config_cmd_fifo_put,
+                                     p_vci_tgt_int.pktid.read() );
+    m_config_cmd_data_fifo.update(   config_cmd_fifo_get,
+                                     config_cmd_fifo_put,
+                                     (ext_data_t)p_vci_tgt_int.wdata.read() );
+    m_config_cmd_be_fifo.update(     config_cmd_fifo_get,
+                                     config_cmd_fifo_put,
+                                     p_vci_tgt_int.be.read() );
+    m_config_cmd_eop_fifo.update(    config_cmd_fifo_get,
+                                     config_cmd_fifo_put,
+                                     p_vci_tgt_int.eop.read() );
     
-    //////////////////
-    //CONFIG_RSP Fifo
-    //////////////////
-    m_config_rsp_data_fifo.update( config_rsp_fifo_get,
-                                config_rsp_fifo_put,
-                                p_vci_ini_config.rdata.read() );
-    m_config_rsp_rsrcid_fifo.update( config_rsp_fifo_get,
-                                config_rsp_fifo_put,
-                                r_config_rsrcid.read() );
-    m_config_rsp_rtrdid_fifo.update( config_rsp_fifo_get,
-                                config_rsp_fifo_put,
-                                r_config_rtrdid.read() );
-    m_config_rsp_rpktid_fifo.update( config_rsp_fifo_get,
-                                config_rsp_fifo_put,
-                                p_vci_ini_config.rpktid.read() );
-    m_config_rsp_reop_fifo.update( config_rsp_fifo_get,
-                               config_rsp_fifo_put,
-                               p_vci_ini_config.reop.read() );
-    m_config_rsp_rerror_fifo.update( config_rsp_fifo_get,
-                                  config_rsp_fifo_put,
-                                  p_vci_ini_config.rerror.read() );
+    //////////////////////////////////////////////////////////////////////////
+    // CONFIG_RSP fifo update
+    // There is two writers : CONFIG_CMD FSM & CONFIG_RSP FSM
+    //////////////////////////////////////////////////////////////////////////
+
+    if ( r_alloc_fifo_config_rsp_local.read() )  // owner is CONFIG_CMD FSM
+                                                 // response for a local config transaction 
+    {
+        m_config_rsp_data_fifo.update(   config_rsp_fifo_get,
+                                         config_rsp_fifo_put,
+                                         (int_data_t)r_config_cmd_rdata.read() ); 
+        m_config_rsp_rsrcid_fifo.update( config_rsp_fifo_get,
+                                         config_rsp_fifo_put,
+                                         p_vci_tgt_int.srcid.read() );
+        m_config_rsp_rtrdid_fifo.update( config_rsp_fifo_get,
+                                         config_rsp_fifo_put,
+                                         p_vci_tgt_int.trdid.read() );
+        m_config_rsp_rpktid_fifo.update( config_rsp_fifo_get,
+                                         config_rsp_fifo_put,
+                                         p_vci_tgt_int.pktid.read() );
+        m_config_rsp_reop_fifo.update(   config_rsp_fifo_get,
+                                         config_rsp_fifo_put,
+                                         true );                // local config are one flit
+        m_config_rsp_rerror_fifo.update( config_rsp_fifo_get,
+                                         config_rsp_fifo_put,
+                                         r_config_cmd_error.read() );
+    }
+    else                                         // owner is CONFIG_RSP FSM
+                                                 // response for a remote transaction
+    {
+        m_config_rsp_data_fifo.update(   config_rsp_fifo_get,
+                                         config_rsp_fifo_put,
+                                         (int_data_t)p_vci_ini_iox.rdata.read() );
+        m_config_rsp_rsrcid_fifo.update( config_rsp_fifo_get,
+                                         config_rsp_fifo_put,
+                                         p_vci_ini_iox.rsrcid.read() );
+        m_config_rsp_rtrdid_fifo.update( config_rsp_fifo_get,
+                                         config_rsp_fifo_put,
+                                         p_vci_ini_iox.rtrdid.read() );
+        m_config_rsp_rpktid_fifo.update( config_rsp_fifo_get,
+                                         config_rsp_fifo_put,
+                                         p_vci_ini_iox.rpktid.read() );
+        m_config_rsp_reop_fifo.update(   config_rsp_fifo_get,
+                                         config_rsp_fifo_put,
+                                         p_vci_ini_iox.reop.read() );
+        m_config_rsp_rerror_fifo.update( config_rsp_fifo_get,
+                                         config_rsp_fifo_put,
+                                         p_vci_ini_iox.rerror.read() );
+    }
     
-    ///////////////////////
-    //CONFIG Local RSP Fifo
-    ///////////////////////
-    m_config_local_rsrcid_fifo.update( config_local_fifo_get,
-                                config_local_fifo_put,
-                                p_vci_tgt_config.srcid.read() );
-    m_config_local_rtrdid_fifo.update( config_local_fifo_get,
-                                config_local_fifo_put,
-                                p_vci_tgt_config.trdid.read() );
-    m_config_local_rpktid_fifo.update( config_local_fifo_get,
-                                config_local_fifo_put,
-                                p_vci_tgt_config.pktid.read() );
-    
-    switch( r_config_cmd_fsm.read() ) 
-    {
-    case CONFIG_CMD_PTPR_WRITE:
-    case CONFIG_CMD_ACTIVE_WRITE:
-    case CONFIG_CMD_IT_ADDR_IOMMU_WRITE_2:
-    case CONFIG_CMD_IT_ADDR_WRITE_2:
-    case CONFIG_CMD_INVAL:
-        m_config_local_data_fifo.update( config_local_fifo_get,
-                                config_local_fifo_put,
-                                0); 
-        m_config_local_rerror_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        WRITE_OK );
-        m_config_local_reop_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        true );
-        break;
-    case CONFIG_CMD_PTPR_READ:
-        m_config_local_data_fifo.update( config_local_fifo_get,
-                                config_local_fifo_put,
-                                r_iommu_ptpr.read()); 
-        m_config_local_rerror_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        READ_OK );
-        m_config_local_reop_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        true );
-        break;
-    case CONFIG_CMD_ACTIVE_READ:
-        m_config_local_data_fifo.update( config_local_fifo_get,
-                                config_local_fifo_put,
-                                r_iommu_active.read()); 
-        m_config_local_rerror_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        READ_OK );
-        m_config_local_reop_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        true );
-        break;
-    case CONFIG_CMD_BVAR_READ:
-        m_config_local_data_fifo.update( config_local_fifo_get,
-                                config_local_fifo_put,
-                                r_iommu_bvar.read()); 
-        m_config_local_rerror_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        READ_OK );
-        m_config_local_reop_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        true );
-        break;
-    case CONFIG_CMD_ETR_READ:
-        m_config_local_data_fifo.update( config_local_fifo_get,
-                                config_local_fifo_put,
-                                r_iommu_etr.read()); 
-        m_config_local_rerror_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        READ_OK );
-        m_config_local_reop_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        true );
-        break;
-    case CONFIG_CMD_BAD_ID_READ:
-        m_config_local_data_fifo.update( config_local_fifo_get,
-                                config_local_fifo_put,
-                                r_iommu_bad_id.read()); 
-        m_config_local_rerror_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        READ_OK );
-        m_config_local_reop_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        true );
-        break;
-    case CONFIG_CMD_IT_ADDR_IOMMU_READ_1:
-        m_config_local_data_fifo.update( config_local_fifo_get,
-                                config_local_fifo_put,
-                                (uint32_t)(r_it_addr_iommu.read() & 0xFFFFFFFF) ); 
-        m_config_local_rerror_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        READ_OK );
-        m_config_local_reop_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        false );
-        break;
-    case CONFIG_CMD_IT_ADDR_IOMMU_READ_2:
-        m_config_local_data_fifo.update( config_local_fifo_get,
-                                config_local_fifo_put,
-                               (uint32_t)((r_it_addr_iommu.read()>>32)&0xFF) ); 
-        m_config_local_rerror_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        READ_OK );
-        m_config_local_reop_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        true );
-        break;
-    case CONFIG_CMD_IT_ADDR_READ_1:
-        m_config_local_data_fifo.update( config_local_fifo_get,
-                                config_local_fifo_put,
-                               (uint32_t)(r_it_addr[r_it_index.read()] & 0xFFFFFFFF) ); 
-        m_config_local_rerror_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        READ_OK );
-        m_config_local_reop_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        false );
-        break;
-    case CONFIG_CMD_IT_ADDR_READ_2:
-        m_config_local_data_fifo.update( config_local_fifo_get,
-                                config_local_fifo_put,
-                                (uint32_t)((r_it_addr[r_it_index.read()]>>32)&0xFF) ); 
-        m_config_local_rerror_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        READ_OK );
-        m_config_local_reop_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        true );
-        break;
-    case CONFIG_CMD_ERROR_RSP:
-        m_config_local_data_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        0); 
-        m_config_local_rerror_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        r_config_error_type.read() );
-        m_config_local_reop_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        true );
-        break;
-    default:
-        m_config_local_data_fifo.update( config_local_fifo_get,
-                                config_local_fifo_put,
-                                0); 
-        m_config_local_rerror_fifo.update( config_local_fifo_get,
-                                        config_local_fifo_put,
-                                        0 );
-        m_config_local_reop_fifo.update( config_local_fifo_get,
-                               config_local_fifo_put,
-                               false );
-        break;
-    }
-
 } // end transition()
 
